#include <iostream>
#include <fstream>
#include <cstdlib>
#include <math.h>
#include <time.h>
#include <time.h>

using namespace std;

#define MAIN
#include "ldraw.hpp"

void pause(void)
{
	cout << "Press <Enter> to quit" << endl;
	getchar();
}
void usage(void)
{
	cout << "Flipper [options] InFile Outfile" << endl;
	cout << "-k <val>: key color (default: any != 16)" << endl;
	cout << "-c: Don't manage condlines around split quads" << endl;
	cout << "-u: Return file to uncolored state" << endl;
	pause();
}

int main(int argc, char *argv[])
{
	printf("\nFlipper 1.0 - by Philo");
	printf("\n----------------------\n");

	if(argc<3) 
	{
		usage();
		return 1;
	}
	bool UnifyOutput=true;

	LdPath* path=new LdPath();
	// Get input file path
	string curpath=argv[argc-2];
	size_t pathlen = curpath.find_last_of("\\");
	if(pathlen == string::npos) curpath = ".\\"; else curpath.resize(pathlen+1);
	path->addPath(curpath);
	string derivedpath=curpath;
	path->addPath(derivedpath.append("p\\"));
	derivedpath=curpath;
	path->addPath(derivedpath.append("s\\"));

	for(int i=1; i<argc-2; i++)
	{
		if(argv[i][0] != '-')
		{
			usage();
			return 1;
		}
		switch (argv[i][1])
		{
		case 'k':
			i++;
			sscanf(argv[i], "%d",&KeyColor);
			break;
		case 'c':
			ManageCond=false;
			break;
		case 'u':
			Uncolor=true;
			break;
		default:
			usage();
			return 1;
		}
	}

	Fldraw LDfile;
	cout << endl << "Reading input file " << argv[argc-2] << endl;
	if(!LDfile.ldLoad (argv[argc-2]))
	{
		cout << argv[argc-2] << " not found" << endl;
		pause();
		return 2;
	}

	cout << "\nFlipping triangles\n";
	LDfile.FlipTris();
	cout << endl;
	

	if(Uncolor)
	{
		cout << endl << "Return file to uncolored state" << endl;
		LDfile.unColor();
	}
	cout << endl << "Writing output file " << argv[argc-1] << endl;
	if(!LDfile.ldSave(argv[argc-1]))
	{
		cout <<" Can't create" << argv[argc-1] << endl;
		pause();
		return 2;
	}
	pause();
	return 0;
}

